function error(message, skipLog) {													// send error message
	if (!skipLog)
		appendLog(message, 'color:red;font-weight:bold;');
	if (errormode)
		window.openDialog("chrome://fireftp/content/alertDialog.xul","alertDialog",
			"screenY="+(document.getElementById('main-window').boxObject.height/2 - 100+document.getElementById('main-window').boxObject.screenY)
		  +",screenX="+(document.getElementById('main-window').boxObject.width /2 - 200+document.getElementById('main-window').boxObject.screenX)+
			",width=400,height=200,chrome,modal=yes,dialog=yes,resizable=yes", message);
	document.getElementById('statusbytes').label = "";
	document.getElementById('statusmeter').setAttribute("mode", "determined");
	document.getElementById('statusmeter').setAttribute("value", "0%");
}
function detailedError(msg, url, linenumber) {
	if (debugmode && linenumber)
		error('Error message= ' + msg + '\nURL= ' + url + '\nLine Number= ' + linenumber, false);
}
function debug(message, errornum, level) {											// add debug message to log; last error number is currently 42
	var type = level ? level : "Error";
	if (debugmode)
		appendLog(type + " " + errornum + ": " + message, 'color:red;font-weight:bold;');
}
function sendAbort() {
	isReconnecting = false;
	progressEventSink.sendBytesTotal = 0;											// stop uploads
	document.getElementById('statusbytes').label = "";								// reset status bar
	document.getElementById('statusmeter').setAttribute("mode", "determined");
	document.getElementById('statusmeter').setAttribute("value", "0%");
	if (!isConnected)
		return;
	//XXX writeControl("ABOR"); 													// see note below

	document.getElementById('statusbytes').label = strbundle.getString("working");	// still connected, try clearing queue and refreshing
	document.getElementById('statuselapsed').label = "";
	document.getElementById('statusremaining').label = "";
	document.getElementById('statusrate').label = "";
	document.getElementById('statusmeter').setAttribute("mode", "undetermined");

	try {
		data_transport.close("Finished"); 											// ABOR does not seem to stop the connection in most cases
																					// so this is a more direct approach
		data_finished = true;
		if (file_instream)
			file_instream.close();
	} catch (ex) { debug(ex,38); }

	eventQueue = new Array;
	addEventQueue("aborted");
	localTree.refresh();
	remoteTree.refresh();
}
function recoverFromDisaster() {													// after connection lost, try to restart queue
	if (eventQueue.length && eventQueue[0].cmd == "goodbye")
		eventQueue.shift();
	if (eventQueue.cmd)
		eventQueue = new Array(eventQueue);
	if (eventQueue.length && (eventQueue[0].cmd == "LIST" || eventQueue[0].cmd == "LIST2"
			|| eventQueue[0].cmd == "RETR" || eventQueue[0].cmd == "RETR2"
			|| eventQueue[0].cmd == "REST" || eventQueue[0].cmd == "APPE"
			|| eventQueue[0].cmd == "STOR" || eventQueue[0].cmd == "STOR2"
			|| eventQueue[0].cmd == "PASV" || eventQueue[0].cmd == "APPE2")) {
		var cmd = eventQueue[0].cmd;
		var parameter = eventQueue[0].parameter;
		if (cmd == "LIST2" || cmd == "RETR2" || cmd == "STOR2" || cmd == "APPE2")
			eventQueue[0].cmd = eventQueue[0].cmd.substring(0,4);
		cmd = eventQueue[0].cmd;

		// set up resuming for these poor interrupted transfers
		if (cmd == "REST") {
			try {
				var file = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
				file.initWithPath(eventQueue[1].remember);
				if (file.fileSize)
					eventQueue[0].parameter = file.fileSize;
			} catch(ex) { debug(ex,39); }
		} else if (cmd == "RETR") {
			try {
				var file = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
				file.initWithPath(eventQueue[0].remember);
				if (file.fileSize)
					eventQueue.unshift({ cmd: "REST", parameter: file.fileSize, remember: "" });
			} catch(ex) { debug(ex,40); }
		}

		// find the missing commands that complete the sets - this is where TYPE is handy
		var found = -1;
		var tempQueue = new Array;
		for (var x = 0; x < trashQueue.length; ++x)
			if (trashQueue[x].cmd == "TYPE" || found != -1) {
				tempQueue.push(trashQueue[x]);
				found = x;
			}
		eventQueue = tempQueue.concat(eventQueue);// ah, that's better

		// more resuming fun - this time for the stor/appe commandds
		if (cmd == "STOR" || cmd == "APPE")
			eventQueue.unshift({ cmd: "SIZE", parameter: parameter, remember: cmd });
	} else if (eventQueue.length && eventQueue[0].cmd == "RNTO") {					// don't worry RNTO, i didn't forget about you :)
		if (trashQueue[trashQueue.length - 1].cmd == "RNFR")
			eventQueue.unshift(trashQueue[trashQueue.length - 1]);					// ah, that's better
	}
	trashQueue = new Array;
}
function checkTimeout(id, cmd, dataSocket) {										// uploads currently can't be used with this function - we ignore them
	//if (eventQueue.length && (eventQueue[0].cmd.indexOf("APPE") != -1 || eventQueue[0].cmd.indexOf("STOR") != -1))
	//	return;
	if (networkTimeoutID == id && eventQueue.length && (dataSocket || eventQueue[0].cmd.indexOf(cmd) != -1)) { // still stuck on a command
		legitClose = false;															// trying to restart the connection after a timeout
		close();																	// try to restart the connection the hard way
	}
}
