var localFile = {
	launch : function(file) {
		try {
			if (file.exists())
				file.launch();
		} catch (ex) { debug(ex,37); }
	},
	createDirectory : function() {
		var name = window.prompt(strbundle.getString("directoryName"), "", strbundle.getString("newDirectory"));
		if (!name)
			return null;

		var dir = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
		dir.initWithPath(localTree.constructPath(gLocalPath.value, name));
		try {
			dir.create(Components.interfaces.nsILocalFile.DIRECTORY_TYPE, 755);							// create the directory
		} catch (ex) {
			error(strbundle.getString("dirFail"));
			debug(ex,33);
			return null;
		}
		return dir;
	},
	remove : function(file, prompt, multiple) {
		if (prompt && multiple && multiple > 1) {
			if (!window.confirm(strbundle.getString("confirmDelete") + " " + multiple + " " + strbundle.getString("confirmDelete2")
					   + '\n' + strbundle.getString("localDeleteWarning")))
				return false;
		} else if (prompt && file.isDirectory()) {										// deleting a directory
			if (!window.confirm(strbundle.getString("confirmDelete") + " '" + file.leafName + "' " + strbundle.getString("confirmDelete3")
					   + '\n' + strbundle.getString("localDeleteWarning")))
				return false;
		} else if (prompt) {															// deleting a file
			if (!window.confirm(strbundle.getString("confirmDelete") + " '" + file.leafName + "'?" + '\n' + strbundle.getString("localDeleteWarning")))
				return false;
		}

		try {
			file.remove(true);															// delete file (recursively if dir)
		} catch (ex) {
			error(strbundle.getString("delFail"));
			debug(ex,34);
			return false;
		}
		return true;
	},
	rename : function(file) {
		if (!file.exists())											// check it exists
			return false;

		var newName = window.prompt(strbundle.getString("renameTo"), file.leafName, strbundle.getString("rename"));
		if (!newName || file.leafName == newName)
			return false;

		try {
			file.moveTo(null, newName);								// rename the file
		} catch (ex) {
			error(strbundle.getString("renameFail"));
			debug(ex,32);
			return false;
		}
		return true;
	},
	showProperties : function(file) {
		try {
			var date = new Date(file.lastModifiedTime);
			date = months[date.getMonth()] + ' ' + date.getDate() + ' ' + date.getFullYear() + ' ' + date.toLocaleTimeString();

			window.openDialog("chrome://fireftp/content/propertiesDialog.xul","propertiesDialog",
					"screenY="+(document.getElementById('main-window').boxObject.height/2 - 100+document.getElementById('main-window').boxObject.screenY)
				  +",screenX="+(document.getElementById('main-window').boxObject.width /2 - 300+document.getElementById('main-window').boxObject.screenX)
				  +",width=600,height=200,chrome,modal=yes,dialog=yes,resizable=yes",
					 file.path, file.leafName, file.fileSize, date, 0, file.isWritable(), file.isHidden(), file.isDirectory());
		} catch (ex) { debug(ex,41); }
	},
}
